"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validateWebglRendererSettings = validateWebglRendererSettings;
exports.WEBGL_RENDERER_DEFAULT_SETTINGS = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/**
 * Sigma.js WebGL Renderer Settings
 * =================================
 *
 * The list of settings for the WebGL renderer and some handy functions.
 */
function validateWebglRendererSettings(settings) {
  // Label grid cell
  if (settings.labelGrid && settings.labelGrid.cell && _typeof(settings.labelGrid.cell) === 'object' && (!settings.labelGrid.cell.width || !settings.labelGrid.cell.height)) {
    throw new Error('sigma/renderers/webgl/settings: invalid `labelGrid.cell`. Expecting {width, height}.');
  }
}

var WEBGL_RENDERER_DEFAULT_SETTINGS = {
  // Performance
  hideEdgesOnMove: false,
  hideLabelsOnMove: false,
  renderLabels: true,
  // Component rendering
  defaultNodeColor: '#999',
  defaultNodeType: 'circle',
  defaultEdgeColor: '#ccc',
  defaultEdgeType: 'line',
  labelFont: 'Arial',
  labelSize: 14,
  labelWeight: 'normal',
  // Labels
  labelGrid: {
    cell: null,
    renderedSizeThreshold: -Infinity
  },
  // Reducers
  nodeReducer: null,
  edgeReducer: null,
  // Features
  zIndex: false
};
exports.WEBGL_RENDERER_DEFAULT_SETTINGS = WEBGL_RENDERER_DEFAULT_SETTINGS;